import { defineComponent as f, computed as m, openBlock as d, createElementBlock as s, normalizeClass as h, renderSlot as y, createTextVNode as x, ref as c, createElementVNode as B, toDisplayString as L, createCommentVNode as k } from "vue";
const $ = ["type", "disabled", "aria-disabled"], I = /* @__PURE__ */ f({
  __name: "FuiButton",
  props: {
    variant: { default: "primary" },
    size: { default: "medium" },
    disabled: { type: Boolean, default: !1 },
    type: { default: "button" },
    fullWidth: { type: Boolean, default: !1 }
  },
  emits: ["click"],
  setup(a, { emit: l }) {
    const e = a, u = l, i = m(() => [
      "foundation-button",
      `foundation-button--${e.variant}`,
      `foundation-button--${e.size}`,
      {
        "foundation-button--disabled": e.disabled,
        "foundation-button--full-width": e.fullWidth
      }
    ]), t = (o) => {
      e.disabled || u("click", o);
    };
    return (o, r) => (d(), s("button", {
      class: h(i.value),
      type: e.type,
      disabled: e.disabled,
      onClick: t,
      "aria-disabled": e.disabled
    }, [
      y(o.$slots, "default", {}, () => [
        r[0] || (r[0] = x("Button"))
      ], !0)
    ], 10, $));
  }
}), b = (a, l) => {
  const e = a.__vccOpts || a;
  for (const [u, i] of l)
    e[u] = i;
  return e;
}, C = /* @__PURE__ */ b(I, [["__scopeId", "data-v-5fcca828"]]), V = { class: "foundation-input-wrapper" }, q = ["type", "value", "placeholder", "disabled", "required", "minlength", "maxlength", "pattern", "aria-invalid", "aria-describedby"], F = {
  key: 0,
  id: "input-error",
  class: "foundation-input-error"
}, z = /* @__PURE__ */ f({
  __name: "FuiInput",
  props: {
    modelValue: {},
    type: { default: "text" },
    placeholder: {},
    disabled: { type: Boolean, default: !1 },
    required: { type: Boolean, default: !1 },
    minLength: {},
    maxLength: {},
    pattern: {},
    variant: { default: "default" },
    size: { default: "medium" }
  },
  emits: ["update:modelValue", "input", "focus", "blur"],
  setup(a, { emit: l }) {
    const e = a, u = l, i = c(null), t = c(""), o = m(() => [
      "foundation-input",
      `foundation-input--${e.variant}`,
      `foundation-input--${e.size}`,
      {
        "foundation-input--disabled": e.disabled,
        "foundation-input--error": t.value
      }
    ]), r = () => {
      if (!i.value) return !0;
      const n = i.value.value;
      return e.required && !n ? (t.value = "This field is required", !1) : e.minLength && n.length < e.minLength ? (t.value = `Minimum length is ${e.minLength} characters`, !1) : e.maxLength && n.length > e.maxLength ? (t.value = `Maximum length is ${e.maxLength} characters`, !1) : e.pattern && !new RegExp(e.pattern).test(n) ? (t.value = "Invalid input format", !1) : (t.value = "", !0);
    }, v = (n) => {
      const p = n.target;
      u("update:modelValue", p.value), u("input", n), r();
    }, _ = (n) => {
      u("focus", n);
    }, g = (n) => {
      u("blur", n), r();
    };
    return (n, p) => (d(), s("div", V, [
      B("input", {
        ref_key: "inputRef",
        ref: i,
        class: h(o.value),
        type: e.type,
        value: e.modelValue,
        placeholder: e.placeholder,
        disabled: e.disabled,
        required: e.required,
        minlength: e.minLength,
        maxlength: e.maxLength,
        pattern: e.pattern,
        onInput: v,
        onFocus: _,
        onBlur: g,
        "aria-invalid": !!t.value,
        "aria-describedby": t.value ? "input-error" : void 0
      }, null, 42, q),
      t.value ? (d(), s("span", F, L(t.value), 1)) : k("", !0)
    ]));
  }
}), w = /* @__PURE__ */ b(z, [["__scopeId", "data-v-fb90c776"]]), M = {
  install(a) {
    a.component("FuiButton", C), a.component("FuiInput", w);
  }
};
export {
  C as Button,
  w as Input,
  M as default
};
